#pragma once

#include "strike7api.h"

namespace MCStrike7
{
	class __declspec(dllexport) Applet
	{
	public:
		
		Applet( const TCHAR* name, uint32_t iconWidth, uint32_t iconHeight, void *iconRGBA );
		virtual ~Applet();

		void Draw( int32_t x, int32_t y, uint32_t w, uint32_t h, void *data );
		void Fill( int32_t x, int32_t y, uint32_t w, uint32_t h, uint32_t colour );
		void DrawText( int32_t x, int32_t y, uint32_t size, uint32_t colour, const TCHAR* text );
		void Scroll( uint32_t x, uint32_t y, uint32_t w, uint32_t height, int32_t dx, int32_t dy );
		void UpdateScreen();

		virtual void OnAppletActive() {}
		virtual void OnAppletInactive() {}
		virtual void OnAppletReset() {}
		virtual void OnAppletTouch( uint32_t x, uint32_t y, bool pressed ) {}

	protected:

		Applet();
		void OpenApplet( const TCHAR* name, uint32_t iconWidth, uint32_t iconHeight, void *iconRGBA );

	private:

		uint16_t m_appletId;
	};

}