
#include "applet.h"
#include <windows.h>
#include <gdiplus.h>

class MapApplet : public MCStrike7::Applet
{
	int m_x;
	int m_y;

	int m_mapWidth;
	int m_mapHeight;

	bool m_pressed;
	int m_lastTouchX;
	int m_lastTouchY;

	int m_scrollX;
	int m_scrollY;

	//static void CALLBACK  
	UINT32 m_timer;
	HANDLE m_semaphore;

	Gdiplus::Bitmap *m_map;

	static void Event_ScreenUpdateTimer_Elapsed();

	static VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg,  UINT_PTR idEvent, DWORD dwTime);

public:

	MapApplet(Gdiplus::Bitmap *image);
	~MapApplet();
                
	void OnAppletActive();
	void OnAppletInactive();
	void OnAppletReset();
	void OnAppletTouch(uint32_t x, uint32_t y, bool pressed);
	void UpdateWholeMap();
	void UpdateScreenForScroll();
	void UpdateMapSection(int x, int y, int fromX, int fromY, int width, int height);

	void ScrollMap(int dx, int dy);



};
